#include ecos:shaders/pass/header.glsl
#include ecos:shaders/lib/tonemap.glsl

uniform sampler2D composite_result;
uniform sampler2D bloom_result;

in vec2 texcoord;
out vec4 fragColor;

void main()
{
    vec3 emission = textureLod(bloom_result, texcoord, 0).rgb;
    vec3 bloom = max(textureLod(bloom_result, texcoord, 4).rgb, emission);

    fragColor.rgb = texture(composite_result, texcoord).rgb;

    //reverse tonemap
    fragColor.rgb = reverse_tonemap(fragColor.rgb);

    fragColor.rgb += bloom;

    // tonemap again lol
    fragColor.rgb = tonemap(fragColor.rgb);
}