#include frex:shaders/api/fragment.glsl
#include frex:shaders/api/world.glsl
#include ecos:shaders/pbr/material.glsl

void frx_materialFragment() {
  #ifdef ECOS_WATER
    float time = frx_renderSeconds + 1.0;
    vec2 obj_coord = frx_vertex.xz + frx_cameraPos.xz;
    vec2 noise_coord1 = floor(obj_coord * 4.0) / 4.0;
    vec2 noise_coord2 = noise_coord1;
    vec2 blob_coord = obj_coord;
    
    noise_coord1.x += time;
    noise_coord2.x -= time;
    blob_coord.x += time; 

    noise_coord1.y *= 2.0;
    noise_coord2.y *= 2.0;

    const float scale = 32.0;
    const float scale_blob = 320.0;

    float peaks = texture(noise_texture, noise_coord1 / scale).r;
    peaks += texture(noise_texture, noise_coord2 / scale).r;
    float blob = texture(noise_texture, blob_coord / scale_blob).r;

    peaks = smoothstep(1.4, 2.0, peaks);
    peaks *= smoothstep(0.5, 1.0, blob);
    peaks *= smoothstep(0.9, 1.0, frx_vertexNormal.y);

    frx_fragColor.a = mix(frx_fragColor.a * 0.6, 1.0, smoothstep(0.0, 128.0, frx_distance));
    frx_fragColor.rgb = frx_fragColor.rgb * 0.4 + 0.4 * frx_vertexColor.rgb * frx_vertexColor.rgb + vec3(0.0, 0.2, 0.0);
    frx_fragColor += peaks * vec4(1.0, 2.0, 2.0, 1.0 - frx_fragColor.a);
    frx_fragEmissive += peaks * 2.0;
  #endif
}